#include "bits/stdc++.h"
#define puba push_back
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }
const int P = 239, MOD = 1e9 + 7;

vector<int> get_hash(string s) {
    vector<int> ret = {0};
    for (char c : s) {
        ret.puba(((ll) ret.back() * P + c) % MOD);
    }
    return ret;
}

const int MAXN = 2e6 + 5;

int pp[MAXN];

int seg_hash(vector<int> const& arrh, int l, int r) {
    int tmp = (arrh[r] - (ll) arrh[l] * pp[r - l]) % MOD;
    if (tmp < 0) {
        tmp += MOD;
    }
    return tmp;
}


int main() {
    //freopen(TASK_NAME ".in", "r", stdin);
    //freopen(TASK_NAME ".out", "w", stdout);
    cerr << fixed << setprecision(15);
    cout << fixed << setprecision(15);
    ios::sync_with_stdio(false);
    
    pp[0] = 1;
    for (int i = 1; i < MAXN; ++i) {
        pp[i] = (ll) pp[i - 1] * P % MOD;
    }

    string s;
    cin >> s;
    int n = szof(s);
    s = s + s;
    
    auto hlr = get_hash(s);
    reverse(bend(s));
    auto hrl = get_hash(s);
    int ans = 0;
    for (int i = 0; i < szof(s); ++i) {
        int l = 0, r = szof(s);
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (i - mid >= 0 && i + mid < szof(s)) {
                if (seg_hash(hlr, i - mid, i + mid + 1) == seg_hash(hrl, szof(s) - (i + mid + 1), szof(s) - (i - mid))) {
                    l = mid;
                } else {
                    r = mid;
                }
            } else {
                r = mid;
            }
        }
        int tmp = l * 2 + 1;
        if (tmp > n) {
            tmp -= (tmp - n + 1) / 2 * 2;
        }
        ans = max(ans, tmp);

        l = 0, r = szof(s);
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (i - mid + 1 >= 0 && i + mid < szof(s)) {
                if (seg_hash(hlr, i - mid + 1, i + mid + 1) == seg_hash(hrl, szof(s) - (i + mid + 1), szof(s) - (i - mid + 1))) {
                    l = mid;
                } else {
                    r = mid;
                }
            } else {
                r = mid;
            }
        }

        tmp = l * 2;
        if (tmp > n) {
            tmp -= (tmp - n + 1) / 2 * 2;
        }
        ans = max(ans, tmp);
    }

    cout << ans << "\n";
    
    
    #ifdef LOCAL
        cerr << "time: " << clock() << endl;
    #endif
    return 0;
}