
import java.io.*;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Random;
import java.util.StringTokenizer;

public class Main
{

    public Main() throws IOException
    {

    }

    long inf = (long) 1e18;

    long max(long a, long b)
    {
        return Math.max(a, b);
    }

    int n, k;

    long dp[][][];
    long mx[][][];
    int g[][];
    int val[];
    int deg[];
    int a[], b[];
    int sz[];

    void dfs(int v, int pr)
    {
        sz[v] = 1;
        for (int i = 0; i < deg[v]; i++)
        {
            int to = g[v][i];
            if (to != pr)
            {
                dfs(to, v);
            }
        }
        for (int t = 0; t < 2; t++)
        {
            for (int sum = 0; sum <= k; sum++)
            {
                for (int type = 0; type < 3; type++)
                {
                    mx[t][sum][type] = -inf;
                    dp[v][sum][type] = -inf;
                }
            }
        }
        mx[0][0][0] = 0;
        mx[0][1][1] = val[v];
        int t = 0;
        for (int i = 0; i < deg[v]; i++)
        {
            int to = g[v][i];
            if (to != pr)
            {
                for (int x = 0; x <= sz[v] && x <= k; x++)
                {
                    for (int y = 0; y <= sz[to] && y <= k && x + y <= k + 1; y++)
                    {
                        for (int cur = 0; cur < 3; cur++)
                        {
                            for (int there = 0; there < 3; there++)
                            {
                                for (int now = cur; now < 3; now++)
                                {
                                    if (cur == 0 && now == 0)
                                    {
                                        mx[t ^ 1][x + y][0] = max(mx[t ^ 1][x + y][0], mx[t][x][cur] + dp[to][y][there]);
                                    }
                                    else if (cur == 0 && now == 1)
                                    {
                                        if (x + y + 1 <= k)
                                        {
                                            mx[t ^ 1][x + y + 1][1] = max(mx[t ^ 1][x + y + 1][1], mx[t][x][cur] + dp[to][y][there] + val[v]);
                                        }
                                        if (there == 1)
                                        {
                                            mx[t ^ 1][x + y][1] = max(mx[t ^ 1][x + y][1], mx[t][x][cur] + dp[to][y][there] + val[v]);
                                        }
                                    }
                                    else if (cur == 0 && now == 2)
                                    {
                                        //dj ti chto
                                    }
                                    else if (cur == 1 && now == 1)
                                    {
                                        mx[t ^ 1][x + y][1] = max(mx[t ^ 1][x + y][1], mx[t][x][cur] + dp[to][y][there]);
                                    }
                                    else if (cur == 1 && now == 2)
                                    {
                                        if (there == 1)
                                        {
                                            if (x + y - 1 >= 0)
                                            {
                                                mx[t ^ 1][x + y - 1][2] = max(mx[t ^ 1][x + y - 1][2], mx[t][x][cur] + dp[to][y][there]);
                                            }
                                        }
                                    }
                                    else if (cur == 2 && now == 2)
                                    {
                                        mx[t ^ 1][x + y][2] = max(mx[t ^ 1][x + y][2], mx[t][x][cur] + dp[to][y][there]);
                                    }
                                }
                            }
                        }
                    }
                }
                for (int x = 0; x <= sz[v] && x <= k; x++)
                {
                    for (int cur = 0; cur < 3; cur++)
                    {
                        mx[t][x][cur] = -inf;
                    }
                }
                t ^= 1;
                sz[v] += sz[to];
            }
        }
        for (int i = 0; i <= k; i++)
        {
            for (int cur = 0; cur < 3; cur++)
            {
                dp[v][i][cur] = mx[t][i][cur];
            }
        }
    }

    private void solve() throws IOException
    {
        n = nextInt();
        k = nextInt();
        val = new int[n];
        for (int i = 0; i < n; i++)
        {
            val[i] = nextInt();
        }
        dp = new long[n][k + 1][3];
        mx = new long[2][k + 2][3];
        a = new int[n - 1];
        b = new int[n - 1];
        g = new int[n][];
        sz = new int[n];
        deg = new int[n];
        for (int i = 0; i < n - 1; i++)
        {
            a[i] = nextInt();
            b[i] = nextInt();
            a[i]--;
            b[i]--;
            deg[a[i]]++;
            deg[b[i]]++;
        }
        for (int i = 0; i < n; i++)
        {
            g[i] = new int[deg[i]];
            deg[i] = 0;
        }
        for (int i = 0; i < n - 1; i++)
        {
            g[a[i]][deg[a[i]]++] = b[i];
            g[b[i]][deg[b[i]]++] = a[i];
        }
        dfs(0, -1);
        out.println(max(dp[0][k][0], max(dp[0][k][1], dp[0][k][2])));
    }

    void sort(int a[])
    {
        Random rand = new Random();
        int n = a.length;
        for (int i = 0; i < n; i++)
        {
            int ind = rand.nextInt(i + 1);
            int t = a[i];
            a[i] = a[ind];
            a[ind] = t;
        }
        Arrays.sort(a);
    }

    public static void main(String[] args) throws IOException
    {
        new Main().run();
    }

    BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    StringTokenizer st;
    PrintWriter out = new PrintWriter(System.out);
    String next() throws IOException
    {
        while (st == null || !st.hasMoreTokens())
        {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    int nextInt() throws IOException
    {
        return Integer.parseInt(next());
    }

    long nextLong() throws IOException
    {
        return Long.parseLong(next());
    }

    private void run() throws IOException
    {
        solve();
        out.close();
    }

}